using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Windows.Forms;
using System.Windows.Forms.Design;

namespace WinForm.Wizard
{
    public class WizardDesigner : ParentControlDesigner
    {
        private DesignerActionListCollection _actionLists;

        public override DesignerActionListCollection ActionLists
        {
            get
            {
                if (_actionLists == null)
                {
                    _actionLists = new DesignerActionListCollection();
                    _actionLists.Add(new WizardActionList(Component));
                }
                return _actionLists;
            }
        }
    }

    internal class WizardActionList : DesignerActionList
    {
        private Wizard wizard;

        public WizardActionList(IComponent component)
            : base(component)
        {
            wizard = component as Wizard;
            ActivateWizardStep = wizard.ActivateWizardStep;
        }

        //ҪЩԵѡ, дһ
        public string[] WizardSteps
        {
            get
            {
                try
                {
                    return wizard.WizardSteps.ToStrings();
                }
                catch {}
                return null;
            }
            set { SetValue("WizardSteps", value); }
        }

        public WizardStep ActivateWizardStep
        {
            get
            {
                try
                {
                    for (int i = 0; i < wizard.WizardSteps.Count; i++)
                    {
                        wizard.WizardSteps.Items(i).Visible = false;
                    }
                    wizard.ActivateWizardStep.Visible = true;
                    return wizard.ActivateWizardStep;
                }
                catch {}

                return null;
            }
            set
            {
                try
                {
                    ActivateWizardStep.Visible = false;
                }
                catch
                {
                }

                SetValue("ActivateWizardStep", value);

                try
                {
                    ActivateWizardStep.Visible = true;
                }
                catch
                {
                }

                for (int i = 0; i < wizard.WizardSteps.Count; i++)
                {
                    if (wizard.WizardSteps.Items(i).Name == value.Name)
                    {
                        SetValue("ActivateStep", i);
                        break;
                    }
                }
            }
        }

        private PropertyDescriptor GetPropertyByName(String propName)
        {
            PropertyDescriptor prop;
            prop = TypeDescriptor.GetProperties(wizard)[propName];
            if (null == prop)
                throw new ArgumentException("Matching StackPanel property not found!", propName);
            else
                return prop;
        }

        private void SetValue(string propertyName, object value)
        {
            GetPropertyByName(propertyName).SetValue(wizard, value);
        }

        public void SetDock()
        {
            wizard.Dock = DockStyle.Fill;
        }

        public void Add_WizardStep()
        {
            wizard.WizardStep_Add("WizardStep" + (wizard.WizardSteps.Count + 1));
            ActivateWizardStep = wizard.ActivateWizardStep;
            wizard.Container.Add(ActivateWizardStep);
        }

        public void Remove_WizardStep()
        {
            wizard.WizardStep_Remove(ActivateWizardStep.Name);
            ActivateWizardStep = wizard.ActivateWizardStep;
        }

        //ָSmart TagЩѡ
        public override DesignerActionItemCollection GetSortedActionItems()
        {
            DesignerActionItemCollection items = new DesignerActionItemCollection();

            string headerName = "Wizard Options";

            //һѡ Category
            items.Add(new DesignerActionHeaderItem(headerName));

            items.Add(new DesignerActionMethodItem(this, "Add_WizardStep", "Add WizardStep", headerName));
            items.Add(new DesignerActionMethodItem(this, "Remove_WizardStep", "Remove WizardStep", headerName));
            //ĸѡCategory, headerNameָ
            items.Add(new DesignerActionPropertyItem("ActivateWizardStep", "ActivateWizardStep", headerName));
            items.Add(new DesignerActionPropertyItem("WizardSteps", "WizardSteps", headerName));

            //ǿؼԵ, ԸSmart TagһLinkButtonִĳЩ
            //this, ˵"RefreshChildrenPosition"ʵ
            items.Add(new DesignerActionMethodItem(this, "SetDock", "Dock in parent", headerName));

            return items;
        }
    }
}